﻿using Infragistics.Win.DataVisualization;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace UltraDataChartCategoryTooltip
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            

            ObservableCollection<SampleData> data = new ObservableCollection<SampleData>();

            for(int i=1; i<5; i++)
            {
                data.Add(new SampleData()
                {
                    Label = "Lbl " + i.ToString(),
                    Value1 = i,
                    Value2 = i*2,
                    Value3 = i*3
                });
            }

            CategoryXAxis xAxis = new CategoryXAxis() { DataSource = data, Label = "Label" };
            NumericYAxis yAxis = new NumericYAxis() { MinimumValue = 0, MaximumValue = 15 };

            ultraDataChart1.Axes.Add(xAxis);
            ultraDataChart1.Axes.Add(yAxis);           

            ultraDataChart1.Series.Add(CreateColumnSeries(xAxis, yAxis, data, "Value1"));
            ultraDataChart1.Series.Add(CreateColumnSeries(xAxis, yAxis, data, "Value2"));
            ultraDataChart1.Series.Add(CreateColumnSeries(xAxis, yAxis, data, "Value3"));
        
            CategoryToolTipLayer layer = new CategoryToolTipLayer() { Brush = Brushes.Black, Outline = Brushes.Red, };          
            ultraDataChart1.Series.Add(layer);
        }      

        public ColumnSeries CreateColumnSeries(CategoryXAxis xAxis, NumericYAxis yAxis, IEnumerable dataSource, string valueMemberPath)
        {
            ColumnSeries series = new ColumnSeries() { XAxis = xAxis, YAxis = yAxis, DataSource = dataSource, ValueMemberPath = valueMemberPath, ShowDefaultTooltip = true };
            series.TooltipContentUpdating += Series_TooltipContentUpdating;
            return series;
        }

        private Control Series_TooltipContentUpdating(object sender, ChartTooltipContentEventArgs e)
        {
            DefaultTooltipControl control = e.CurrentContent as DefaultTooltipControl;
            if (control.ParentForm != null)
            {
                control.ParentForm.BackColor = Color.Black;               
            }
            return e.CurrentContent;            
        }
    }

    public class SampleData
    {
        public string Label { get; set; }
        public int Value1 { get; set; }
        public int Value2 { get; set; }
        public int Value3 { get; set; }
    }
}
